# SloMoMod release 4 by David Bowland
# ./addons/eventscripts/slomomod/slomomod.py

# >>> To configure this addon please see slomomod.cfg (created whent he addon is first loaded) <<<

"""
Controls server timescale for slow motion or speeding up time when only bots are playing. Also provides bullet tracers. Requires only ES 2.0.0.248c+
"""


import cfglib
import es
import gamethread
import os.path
import random

import psyco
psyco.full()


info = es.AddonInfo()
info.name     = 'SloMoMod'
info.version  = '4'
info.basename = 'slomomod'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'SuperDave'



###


config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + '.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')

config.text('This addon will set sv_cheats to 1 when it alters timescale. Of course, when sv_cheats is 1 players will be allowed to cheat.')
config.text('Be aware of this and play with people you trust.')
config.text('"There is no legacy so great as honesty." - William Shakespeare')
config.text('')
config.text('This addon will also suppress the chat area notification of sv_cheats changes while timescale is altered.')
config.text('')
config.text('Thanks to MBchrono for this idea! MB_Bullettime can be found here:')
config.text('http://addons.eventscripts.com/addons/view/mb_bullettime')
config.text('\n')

config.text('***** General options *****')
cvar_cheat_notify = config.cvar('slomomod_cheat_notify', 0,   '0 = sv_cheats notification will only be suppressed when changed by SloMoMod, 1 = sv_cheats notification will be suppressed for the life of the server')
cvar_bomb_planted = config.cvar('slomomod_bomb_planted', 1,   '0 = no slow motion when the bomb is planted, 1 = only end-of-round slow motion when the bomb is planted, 2 = full slow motion when the bomb is planted')
cvar_sound_volume = config.cvar('slomomod_sound_volume', 0.8, 'Default volume to play sounds from 0 to 1 inclusive')
config.text('\n')

config.text('***** Bullet tracer options *****')
cvar_tracer = config.cvar('slomomod_tracer', 1, '0 = no bullet tracers, 1 = show bullet tracers only during slow motion, 2 = always show bullet tracers')
config.text('Note: This option requires eventscripts_noisy on to function. This addon will set eventscripts_noisy to 1 while bullet tracers are in effect.')
config.text('More information on eventscripts_noisy can be found here: http://www.eventscripts.com/pages/Eventscripts_noisy')
cvar_tracer_kill = config.cvar('slomomod_tracer_kill', 0,' 0 = no artificial kill trace, 1 = create an artificial tracer from attackers to victims only when bullet tracers are in effect, 2 = create an artificial tracer from attackers to victims every kill')
config.text('Note: This option does NOT require eventscripts_noisy to function.')
cvar_tracer_everyimpact = config.cvar('slomomod_tracer_everyimpact', 1, '0 = only one tracer per weapon fire is allowed, 1 = trace all bullet impacts')
config.text('')
cvar_tracer_width_start   = config.cvar('slomomod_tracer_width_start',   3,   'Width of tracers at the player')
cvar_tracer_width_end     = config.cvar('slomomod_tracer_width_end',     1,   'Width of tracers at bullet impact')
cvar_tracer_noise_min     = config.cvar('slomomod_tracer_noise_min',     0,   'Minumim amount of noise (vibration) in tracers')
cvar_tracer_noise_max     = config.cvar('slomomod_tracer_noise_max',     3,   'Maximum amount of noise (vibration) in tracers')
cvar_tracer_delay_display = config.cvar('slomomod_tracer_delay_display', 3,   'Number of seconds tracers are displayed')
cvar_tracer_delay_fade    = config.cvar('slomomod_tracer_delay_fade',    1.5, 'Number of seconds tracers take to fade out')
cvar_tracer_brightness    = config.cvar('slomomod_tracer_brightness',    255, 'Brightness of tracers from 0 to 255 inclusive')
cvar_tracer_model         = config.cvar('slomomod_tracer_model',         'sprites/laser.vmt', 'Model of bullet tracers relative to ./materials/ with .vmt extension--model will not be downloaded by clients automatically')
config.text('')
config.cvar('slomomod_tracer_color_t_red',    200, 'Intensity of red in Terrorist tracers from 0 to 255 inclusive')
config.cvar('slomomod_tracer_color_t_green',  0,   'Intensity of green in Terrorist tracers from 0 to 255 inclusive')
config.cvar('slomomod_tracer_color_t_blue',   0,   'Intensity of blue in Terrorist tracers from 0 to 255 inclusive')
config.cvar('slomomod_tracer_color_ct_red',   0,   'Intensity of red in Counter-Terrorist tracers from 0 to 255 inclusive')
config.cvar('slomomod_tracer_color_ct_green', 0,   'Intensity of green in Counter-Terrorist tracers from 0 to 255 inclusive')
config.cvar('slomomod_tracer_color_ct_blue',  200, 'Intensity of blue in Counter-Terrorist tracers from 0 to 255 inclusive')
config.text('\n')

config.text('***** Trigger options *****')
config.text('')
config.text('Use the following command to define when timescale should be altered:')
config.text('')
config.text('slomomod_add <trigger> <duration> <timescale> [interruptible] [sound] [volume]')
config.text('')
config.text('   trigger - Name of the trigger the settings apply to (see below for a list of trigger names)')
config.text('   duration - Duration of slow motion in seconds')
config.text('   timescale - Number of game seconds that elapse in one real second during the slow motion')
config.text('   interruptible - 0 = slow motion event cannot be interrupted by other events, 1 = slow motion event can be interrupted by other events')
config.text('      - If omitted, interruptible defaults to 1')
config.text('   sound - Sound to play when slow motion starts relative to ./sound/ and including extension -- automatically marked for download')
config.text('      - If omitted, sound defaults to none ("")')
config.text('   volume - Volume of sound from 0 to 1 inclusive')
config.text('      - If omitted, volume defaults to the value of slomomod_sound_volume')

config.text('Place your slomomod_add commands below:')
config.command('slomomod_add')
config.text('\n')

config.text('Uncomment the following example options if you wish to use them:')
config.text('')
config.text('slomomod_add death_onestanding 9.5 0.1 1 music/stingers/industrial_suspense2.wav')
config.text('   When a player dies leaving one living player: alter timescale to 0.1 seconds per real second for 9.5 seconds, do not let this trigger be interrupted, and play the specified sound.')
config.text('')
config.text('slomomod_add death_lastteam 6 0.2 1 music/stingers/HL1_stinger_song28.mp3')
config.text('   When a player dies leaving no living player on the dead player\'s team: alter timescale to 0.2 seconds per real second for 6 seconds, do not let this trigger be interrupted, and play the specified sound.')
config.text('')
config.text('slomomod_add death_lasthuman 4 0.2')
config.text('   When a human player dies leaving no living human players: alter timescale to 0.2 seconds per real second for 4 seconds.')
config.text('')
config.text('slomomod_add death_#sniper_headshot 2 0.3 1 npc/vort/foot_hit.wav 1')
config.text('   When a player dies from a headshot with a sniper rifle: alter timescale to 0.3 seconds per real second for 2 seconds and play the specified sound at maximum volume.')
config.text('')
config.text('slomomod_add death_hegrenade 2 0.4')
config.text('   When a player dies from an HE grenade: alter timescale to 0.4 seconds per real second for 2 seconds.')
config.text('')
config.text('slomomod_add bomb_exploded 10.5 0.1 0 npc/combine_gunship/gunship_crashing1.wav')
config.text('   When the bomb explodes: alter timescale to 0.1 seconds per real second for 10.5 seconds, play the specified sound.')
config.text('')
config.text('slomomod_add bomb_defused 3 0.5')
config.text('   When the bomb is defused: alter timescale to 0.5 seconds per real second for 3 seconds.')
config.text('')
config.text('slomomod_add roundend_timelimit 3 0.5')
config.text('   When the round ends due to hostages not rescued, target not destroyed, or round draw, alter timescale to 0.5 seconds per real second for 3 seconds.')
config.text('')
config.text('slomomod_add only_bots 0 2.0')
config.text('   When only bots are playing: alter timescale to 2.0 seconds per real second until a human player spawns.')
config.text('\n')

config.text('NOTE: If multiple triggers apply to a single event the most specific trigger will be used.')
config.text('(death_onestanding will be preferred over death_headshot, roundend_timelimit will be preferred over roundend, etc.)')
config.text('')
config.text('Trigger names in approximate order of priority:')
config.text('')
config.text('death_onestanding             - Player death leaving only one player alive')
config.text('death_lastteam                - Player death leaving no live players on the dead player\'s team')
config.text('death_lasthuman               - Player death when the player is the last human (non-bot) player to die')
config.text('humandeath_<weapon>_headshot  - Human player (non-bot) death from a headshot from the <weapon> weapon or weapon type (see below for weapon choices)')
config.text('humankill_<weapon>_headshot   - Player death from a headshot from the <weapon> weapon or weapon type (see below for weapon choices) caused by a human player (non-bot)')
config.text('death_<weapon>_headshot       - Player death from a headshot from the <weapon> weapon or weapon type (see below for weapon choices)')
config.text('humandeath_<weapon>           - Human player (non-bot) death from the <weapon> weapon or weapon type (see below for weapon choices)')
config.text('humankill_<weapon>            - Player death from the <weapon> weapon or weapon type (see below for weapon choices) caused by a human player (non-bot)')
config.text('death_<weapon>                - Player death from the <weapon> weapon or weapon type (see below for weapon choices)')
config.text('humandeath_headshot           - Human player (non-bot) death from a headshot')
config.text('humankill_headshot            - Player death from a headshot caused by a human player (non-bot)')
config.text('death_headshot                - Player death from a headshot')
config.text('humandeath                    - Human player (non-bot) death')
config.text('humankill                     - Player death caused by a human player (non-bot)')
config.text('death                         - Player death')
config.text('bomb_exploded                 - Bomb exploded')
config.text('bomb_defused                  - Bomb defused')
config.text('hostage_killed                - Hostage killed')
config.text('all_hostages_rescued          - All hostages rescued')
config.text('hostage_rescued               - Hostage rescued')
config.text('roundend_timelimit            - Round end due to hostages not rescued, target not destroyed, or round draw')
config.text('roundend                      - Round end')
config.text('only_bots                     - Only bots are playing')
config.text('   * only_bots has no defined duration. It continues until a human player spawns.')
config.text('\n')

config.text('The following weapon types are acceptable to replace <weapon> above and allow headshots (some overlap):')
config.text('')
config.text('#primary')
config.text('#rifle')
config.text('#shotgun')
config.text('#smg')
config.text('#sniper')
config.text('')
config.text('#secondary')
config.text('#pistol')
config.text('\n')

config.text('Headshots can be specified for the following weapons:')
config.text('')
config.text('deagle         - Night Hawk .50C')
config.text('ak47           - CV-47')
config.text('scout          - Schmidt Scout')
config.text('aug            - Bullpup')
config.text('g3sg1          - D3/AU1')
config.text('galil          - IDF Defender')
config.text('famas          - Clarion 5.56')
config.text('m4a1           - Maverick M4A1 Carbine')
config.text('sg552          - Krieg 552')
config.text('sg550          - Krieg 550 Commando')
config.text('m249           - M249')
config.text('awp            - Magnum Sniper Rifle')
config.text('tmp            - Schmidt Machine Pistol')
config.text('mp5navy        - KM Sub-Machine Gun')
config.text('glock          - 9x19mm Sidearm')
config.text('elite          - .40 Dual Elites')
config.text('m3             - Leone 12 Gauge Super')
config.text('xm1014         - Leone YG1265 Auto Shotgun')
config.text('usp            - KM .45 Tactical')
config.text('mac10          - Ingram MAC-10')
config.text('ump45          - KM UMP45')
config.text('p228           - 228 Compact')
config.text('fiveseven      - ES Five-Seven')
config.text('p90            - ES C90')
config.text('')
config.text('The following weapons do not support headshots:')
config.text('')
config.text('hegrenade      - HE Grenade')
config.text('knife          - Knife')
config.text('team           - Team')
config.text('team_suicide   - Suicide')
config.text('other          - Weapon that isn\'t listed')
config.text('\n')

config.text('***** Command documentation *****')
config.text('')
config.text('This addon also makes available the following server commands:')
config.text('')
config.text('slomomod_start <duration> <timescale> [interruptible] [sound] [force sound download] [volume]')
config.text('- Triggers a custom timescale, arguments are similar to slomomod_add but without "trigger".')
config.text('')
config.text('slomomod_end [force end]')
config.text('- Returns timescale to normal')
config.text('   force end - 0 = only end slow motion if it is interruptible, 1 = end slow motion regardless of interruptible status')
config.text('      - If omitted, force end defaults to 0')
config.text('')
config.text('slomomod_remove <trigger>')
config.text('- Removes a trigger by name *Due to the fact triggers can be added and removed above, this command will not be used by most users')
config.text('   trigger - Name of trigger to remove')
config.text('\n')

config.text('***** Event documentation *****')
config.text('')
config.text('The following events will fire when timescale is altered and when timescale is returned to normal, respectively:')
config.text('')
config.text('slomomod_activate')
config.text('   event_var(trigger)         - Name of the trigger that activated slow motion')
config.text('   event_var(duration)        - Duration of the slow motion triggered')
config.text('   event_var(timescale)       - Timescale of the slow motion triggered')
config.text('')
config.text('slomomod_deactivate')
config.text('   event_var(trigger)         - Name of the trigger that activated the expiring slow motion')

config.write()


###


class SloMoManager(object):
   class SloMoTrigger(object):
      soundpath = es.ServerVar('eventscripts_gamedir') + '/sound/'

      def __init__(self, trigger, duration, timescale, interruptible=False, sound='', volume=1.0):
         self.trigger       = trigger
         self.duration      = duration
         self.timescale     = timescale
         self.interruptible = interruptible
         self.sound         = sound
         self.volume        = volume

      def markSoundForDownload(self):
         if os.path.isfile(self.soundpath + self.sound):
            es.stringtable('downloadables', 'sound/' + self.sound)

      def playSound(self):
         if not self.sound: return

         userid = es.getuserid()
         if not userid: return

         es.emitsound('player', userid, self.sound, self.volume, 0.0)

      def isInterruptible(self):
         return self.interruptible

      def getDuration(self):
         return self.duration

      def getTrigger(self):
         return self.trigger

      def applyTimescale(self):
         es.server.cmd('host_timescale %s' % self.timescale)

      def fireActivate(self):
         es.event('initialize', 'slomomod_activate')
         es.event('setstring',  'slomomod_activate', 'trigger',   self.trigger)
         es.event('setfloat',   'slomomod_activate', 'duration',  self.duration)
         es.event('setfloat',   'slomomod_activate', 'timescale', self.timescale)
         es.event('fire',       'slomomod_activate')

      def fireDeactivate(self):
         es.event('initialize', 'slomomod_deactivate')
         es.event('setstring',  'slomomod_deactivate', 'trigger', self.trigger)
         es.event('fire',       'slomomod_deactivate')

   """ Begin SloMoManager """

   current_trigger  = None
   sv_cheats_val    = None
   sv_cheats_var    = es.ServerVar('sv_cheats')
   noisy_var        = es.ServerVar('eventscripts_noisy')
   tracer_status    = 0

   def __init__(self):
      self.triggers         = {}
      self.player_locations = {}

   def _loadEvents(self):
      """Loads the .res file for the events"""
      if os.path.isfile(es.getAddonPath('slomomod') + '/slomomod.res'):
         es.loadevents('declare', 'addons/eventscripts/slomomod/slomomod.res')

      else:
         events = {'slomomod_activate':{'trigger':'string', 'duration':'float', 'timescale':'float'}, 'slomomod_deactivate':{'trigger':'string'}}

         if not os.path.isfile(es.getAddonPath('slomomod') + 'es_slomomod_events_db.txt'):
            es.keygroupcreate('slomomod_events')
            for event_name in events:
               es.keycreate('slomomod_events', event_name)
               for event_name in events[event_name]:
                  es.keysetvalue('slomomod_events', event_name, event_name, events[event_name][event_var])
            es.keygroupsave('slomomod_events', '|slomomod')
            es.keygroupdelete('slomomod_events')
         es.loadevents('declare', 'addons/eventscripts/slomomod/es_slomomod_events_db.txt')
         es.dbgmsg(0, 'SloMoMod: Unable to load slomomod.res! Please ensure it is in the ./slomomod/ directory.')

   """ Trigger functions """

   def addTrigger(self, trigger, duration, timescale, interruptible=True, sound='', volume=None):
      self.triggers[trigger] = self.SloMoTrigger(trigger, duration, timescale, interruptible, sound, cvar_sound_volume if volume is None else volume)

   def removeTrigger(self, trigger):
      if trigger not in self.triggers: return

      if self.current_trigger.getTrigger() == trigger if self.current_trigger else False:
         self.haltCurrentTrigger()
      del self.triggers[trigger]

   def executeTrigger(self, trigger, round_over=False):
      if trigger not in self.triggers: return False

      if (not self.current_trigger.isInterruptible()) if self.current_trigger else False: return False

      bomb_option = int(cvar_bomb_planted)
      if bomb_option <> 2 and es.getentityindex('planted_c4') <> -1 and not (round_over and bomb_option): return False

      self.haltCurrentTrigger(True)
      self.cheatsOn()

      self.current_trigger = self.triggers[trigger]
      self.current_trigger.playSound()
      self.current_trigger.applyTimescale()
      self.current_trigger.fireActivate()

      if trigger == 'only_bots':
         if cvar_tracer <> 2:
            self.tracersOff()

      else:
         if int(cvar_tracer):
            self.tracersOn()
         gamethread.delayedname(self.current_trigger.getDuration(), 'slomomod', self._endCurrentTrigger)

      return True

   def haltCurrentTrigger(self, newtrigger=False, skipbotcheck=False):
      if not self.current_trigger: return

      gamethread.cancelDelayed('slomomod')

      if newtrigger:
         self.current_trigger.fireDeactivate()
      else:
         self._endCurrentTrigger(skipbotcheck)

   def _endCurrentTrigger(self, skipbotcheck=False):
      old_trigger = self.current_trigger.getTrigger()
      self.current_trigger.fireDeactivate()

      self.current_trigger = None
      es.server.cmd('host_timescale 1')
      self.cheatsOff()

      if cvar_tracer == 1:
         self.tracersOff()

      if old_trigger <> 'only_bots' and not skipbotcheck:
         self.triggerOnlyBots()

   def triggerOnlyBots(self):
      if (self.current_trigger.getTrigger() == 'only_bots') if self.current_trigger else False: return

      if filter(lambda x: es.getplayersteamid(x) <> 'BOT' and not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()) or not es.getlivingplayercount(): return False

      return self.executeTrigger('only_bots')

   def getCurrentInterruptible(self):
      return self.current_trigger.isInterruptible() if self.current_trigger else True

   def currentSloMo(self):
      return self.current_trigger

   """ Cheat functions """

   def cheatsOn(self):
      if self.sv_cheats_val is not None: return

      self.sv_cheats_val = int(self.sv_cheats_var)
      es.flags('remove', 'notify', 'sv_cheats')

      es.server.cmd('sv_cheats 1')

   def cheatsOff(self):
      if self.sv_cheats_val is None: return

      if not self.sv_cheats_val:
         es.server.cmd('sv_cheats 0')
      self.sv_cheats_val = None

      if not int(cvar_cheat_notify):
         es.flags('add', 'notify', 'sv_cheats')

   """ Tracer functions """

   def tracersOn(self):
      if self.tracer_status: return

      es.doblock('corelib/noisy_on')
      self.tracer_status = 1

   def tracersOff(self):
      if not self.tracer_status: return

      es.doblock('corelib/noisy_off')

      self.tracer_status = 0
      self.player_locations.clear()

   def clearTracers(self):
      self.player_locations.clear()

   def removeTracer(self, userid):
      if userid in self.player_locations:
         del self.player_locations[userid]

   def weaponFire(self, userid, weapon):
      if not self.tracer_status: return

      if ('#primary' not in weapon_tags[weapon] and '#secondary' not in weapon_tags[weapon]) if weapon_tags.has_key(weapon) else True: return

      player_location     = list(es.getplayerlocation(userid))
      player_location[2] += 45 if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2 else 60
      self.player_locations[userid] = tuple(player_location)

   def bulletImpact(self, userid, impact_location):
      if userid not in self.player_locations: return

      model_index = es.precachemodel(str(cvar_tracer_model))
      team        = 't' if es.getplayerteam(userid) == 2 else 'ct'

      es.effect('beam', '%s,%s,%s' % impact_location, '%s,%s,%s' % self.player_locations[userid], model_index, model_index, 0, 255, cvar_tracer_delay_display, cvar_tracer_width_end, cvar_tracer_width_start, cvar_tracer_delay_fade, random.uniform(float(cvar_tracer_noise_min), float(cvar_tracer_noise_max)), es.ServerVar('slomomod_tracer_color_' + team + '_red'), es.ServerVar('slomomod_tracer_color_' + team + '_green'), es.ServerVar('slomomod_tracer_color_' + team + '_blue'), cvar_tracer_brightness, 10)

      if not int(cvar_tracer_everyimpact):
         del self.player_locations[userid]

   """ Event functions """

   def mapStart(self):
      for trigger in self.triggers:
         self.triggers[trigger].markSoundForDownload()

      self._loadEvents()
      self.haltCurrentTrigger(skipbotcheck=True)
      self.clearTracers()

   def roundStart(self):
      self.haltCurrentTrigger(skipbotcheck=True)
      self.clearTracers()
      self.triggerOnlyBots()

   def roundEnd(self, reason):
      if reason in (10, 12, 13):
         if self.executeTrigger('roundend_timelimit', True): return
      self.executeTrigger('roundend', True)

   def playerSpawn(self, userid):
      if not self.current_trigger: return

      if es.getplayersteamid(userid) <> 'BOT' and self.current_trigger.getTrigger() == 'only_bots':
         self.haltCurrentTrigger()

   def playerDeath(self, userid, attacker, weapon, headshot):
      self._triggerDeath(userid, attacker, weapon, headshot)

      if attacker:
         self.weaponFire(attacker, weapon)

         kill_trace = int(cvar_tracer_kill)
         if kill_trace == 1 and self.tracer_status or kill_trace > 1:
            victim_location     = list(es.getplayerlocation(userid))
            victim_location[2] += 45 if es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2 else 60 + 15 if headshot else 0

            self.bulletImpact(attacker, victim_location)

            if not self.tracer_status:
               del self.player_locations[attacker]

   def _triggerDeath(self, userid, attacker, weapon, headshot):
      round_over  = False
      victim_team = es.getplayerteam(userid)
      if not es.getlivingplayercount(victim_team):
         round_over = victim_team == 3 or es.getentityindex('planted_c4') == -1

         if es.getlivingplayercount() == 1:
            if self.executeTrigger('death_onestanding', round_over): return True

         if self.executeTrigger('death_lastteam', round_over): return True

      victim_isbot = es.getplayersteamid(userid) == 'BOT'
      if not filter(lambda x: es.getplayersteamid(x) <> 'BOT' and not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()) if not victim_isbot else False:
         if self.executeTrigger('death_lasthuman', round_over): return True

      if userid == attacker:
         weapon = 'team_suicide'
      elif victim_team == es.getplayerteam(attacker):
         weapon = 'team'
      elif not weapon_tags.has_key(weapon):
         weapon = 'other'

      attacker_isbot = es.getplayersteamid(attacker) == 'BOT'
      if headshot:
         if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath_%s_headshot' % weapon, 'humankill_%s_headshot' % weapon, 'death_%s_headshot' % weapon): return True

         for tag in weapon_tags[weapon]:
            if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath_%s_headshot' % tag, 'humankill_%s_headshot' % tag, 'death_%s_headshot' % tag): return True

      if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath_%s' % weapon, 'humankill_%s' % weapon, 'death_%s' % weapon): return True

      for tag in weapon_tags[weapon]:
         if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath_%s' % tag, 'humankill_%s' % tag, 'death_%s' % tag): return True

      if headshot:
         if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath_headshot', 'humankill_headshot', 'death_headshot'): return True

      if self._multiTriggerCheck(victim_isbot, attacker_isbot, round_over, 'humandeath', 'humankill', 'death'): return True

      return self.triggerOnlyBots()

   def _multiTriggerCheck(self, victim_isbot, attacker_isbot, round_over, victim_trigger, attacker_trigger, default_trigger):
      if not victim_isbot:
         if self.executeTrigger(victim_trigger, round_over): return True

      if not attacker_isbot:
         if self.executeTrigger(attacker_trigger, round_over): return True

      if self.executeTrigger(default_trigger, round_over): return True

      return False

   def playerDisconnect(self, userid):
      self.removeTracer(userid)

      if es.getplayersteamid(userid) <> 'BOT':
         self.triggerOnlyBots()

   def bombPlanted(self):
      if cvar_bomb_planted == 2: return
      self.haltCurrentTrigger()

   def bombExploded(self):
      self.executeTrigger('bomb_exploded', True)

   def bombDefused(self):
      self.executeTrigger('bomb_defused', True)

   def hostageKilled(self):
      self.executeTrigger('hostage_killed')

   def hostageRescued(self):
      self.executeTrigger('hostage_rescued')

   def hostageRescuedAll(self):
      self.executeTrigger('all_hostages_rescued', True)

slomo = SloMoManager()


###


weapon_tags = {'deagle':('#pistol', '#secondary'), 'ak47':('#rifle', '#primary'), 'scout':('#sniper', '#rifle', '#primary'), 'aug':('#rifle', '#primary'), 'g3sg1':('#sniper', '#rifle', '#primary'), 'galil':('#rifle', '#primary'), 'famas':('#rifle', '#primary'), 'm4a1':('#rifle', '#primary'), 'sg552':('#rifle', '#primary'), 'sg550':('#sniper', '#rifle', '#primary'), 'm249':('#rifle', '#primary'), 'awp':('#sniper', '#rifle', '#primary'), 'tmp':('#smg', '#primary'), 'mp5navy':('#smg', '#primary'), 'glock':('#pistol', '#secondary'), 'elite':('#pistol', '#secondary'), 'm3':('#shotgun', '#primary'), 'xm1014':('#shotgun', '#primary'), 'usp':('#pistol', '#secondary'), 'mac10':('#smg', '#primary'), 'ump45':('#smg', '#primary'), 'p228':('#pistol', '#secondary'), 'fiveseven':('#pistol', '#secondary'), 'p90':('#smg', '#primary'), 'hegrenade':(), 'knife':(), 'team':(), 'team_suicide':(), 'other':()}


def load():
   config.execute()

   if int(cvar_cheat_notify):
      es.flags('remove', 'notify', 'sv_cheats')
   if cvar_tracer == 2:
      slomo.tracersOn()

   slomo.mapStart()
   slomo.roundStart()


def es_map_start(event_var):
   slomo.mapStart()


def round_start(event_var):
   slomo.roundStart()


def round_end(event_var):
   slomo.roundEnd(int(event_var['reason']))


def player_spawn(event_var):
   slomo.playerSpawn(int(event_var['userid']))


def player_death(event_var):
   slomo.playerDeath(int(event_var['userid']), int(event_var['attacker']), event_var['weapon'], event_var['headshot'] == '1')


def player_disconnect(event_var):
   slomo.playerDisconnect(int(event_var['userid']))


def bomb_planted(event_var):
   slomo.bombPlanted()


def bomb_exploded(event_var):
   slomo.bombExploded()


def bomb_defused(event_var):
   slomo.bombDefused()


def hostage_killed(event_var):
   slomo.hostageKilled()


def hostage_rescued(event_var):
   slomo.hostageRescued()


def hostage_rescued_all(event_var):
   slomo.hostageRescuedAll()


def weapon_fire(event_var):
   slomo.weaponFire(int(event_var['userid']), event_var['weapon'])


def bullet_impact(event_var):
   slomo.bulletImpact(int(event_var['userid']), tuple(event_var[x] for x in ('x', 'y', 'z')))


def unload():
   slomo.haltCurrentTrigger(skipbotcheck=True)
   slomo.tracersOff()

   es.server.queuecmd('host_timescale 1')

   for cvar in config.getCvars():
      es.ServerVar(cvar).set(0)


###


def addtrigger_cmd():
   """
   slomomod_add <trigger> <duration> <timescale> [interruptible] [sound] [volume]
   """
   argc = es.getargc()
   if argc in (4, 5, 6, 7):
      args  = []
      types = (None, str, float, float, lambda x: x <> '0', str, float)
      for x in range(1, argc):
         args.append(types[x](es.getargv(x)))

      slomo.addTrigger(*args)

      trigger = args[0]
      if trigger in ('death_onestanding', 'death_lastteam', 'death_lasthuman', 'humandeath_headshot', 'humankill_headshot', 'death_headshot', 'humandeath', 'humankill', 'death', 'bomb_exploded', 'bomb_defused', 'hostage_killed', 'all_hostages_rescued', 'hostage_rescued', 'roundend_timelimit', 'roundend', 'only_bots'): return

      split_trigger = trigger.split('_')
      if len(split_trigger) in (2, 3):
         weapon = split_trigger[1]
         if weapon_tags.has_key(weapon): return

         if filter(lambda x: weapon in weapon_tags[x], weapon_tags): return

         if ((split_trigger[2] == '_headshot') if len(split_trigger) == 3 else False) and weapon in ('hegrenade', 'knife', 'team_suicide'):
            es.dbgmsg(0, 'SloMoMod: Slow motion trigger \"%s\" was added but weapon \"%s\" does not support headshots.' % (trigger, weapon))

      es.dbgmsg(0, 'SloMoMod: Slow motion trigger \"%s\" was added but not recognized.' % trigger)

   else:
      es.dbgmsg(0, 'Syntax: slomomod_add <trigger> <duration> <timescale> [interruptible] [sound] [volume]')

if not es.exists('command', 'slomomod_add'):
   es.regcmd('slomomod_add', 'slomomod/addtrigger_cmd', 'slomomod_add <trigger> <duration> <timescale> [interruptible] [sound] [volume]\nServer command for defining when timescale should be altered')


def removetrigger_cmd():
   """
   slomomod_remove <trigger>
   """
   if es.getargc() == 2:
      slomo.removeTrigger(es.getargv(1))

   else:
      es.dbgmsg(0, 'Syntax: slomomod_remove <trigger>')

if not es.exists('command', 'slomomod_remove'):
   es.regcmd('slomomod_remove', 'slomomod/removetrigger_cmd', 'slomomod_remove <trigger>\nServer command for removing slow motion triggers')


def start_cmd():
   """
   slomomod_start <duration> <timescale> [interruptible] [sound] [volume]
   """
   argc = es.getargc()
   if argc in (3, 4, 5, 6):
      args  = ['custom']
      types = (None, float, float, lambda x: x <> '0', str, float)
      for x in range(1, argc):
         args.append(types[x](es.getargv(x)))

      slomo.addTrigger(*args)
      slomo.executeTrigger('custom')

   else:
      es.dbgmsg(0, 'Syntax: slomomod_start <duration> <timescale> [interruptible] [sound] [volume]')

if not es.exists('command', 'slomomod_start'):
   es.regcmd('slomomod_start', 'slomomod/start_cmd', 'slomomod_start <duration> <timescale> [interruptible] [sound] [volume]\nServer command for starting custom slow motion')


def end_cmd():
   """
   slomomod_end [force end]
   """
   argc = es.getargc()
   if argc in (1, 2):
      if not slomo.currentSloMo(): return

      if slomo.current_trigger.isInterruptible() or (int(es.getargv(1)) if argc == 2 else False):
         slomo.haltCurrentTrigger()

   else:
      es.dbgmsg(0, 'Syntax: slomomod_end [force end]')

if not es.exists('command', 'slomomod_end'):
   es.regcmd('slomomod_end', 'slomomod/end_cmd', 'slomomod_end [force end]\nServer command for restoring timescale to normal')